
-- 
-- Engineer:  Groupe : ADAM HAMZA AYOUB YOUSSEF
-- 
-- Create Date:    21:28:47 24/05/2015 
-- Design Name: 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pwm_gen is
	generic
	(
		PWM_CNT : integer := 50000; -- for 1ms period
		WIDTH : integer := 16 -- in order to accommdate 1000000 count
	);
	port
	(
		clk, reset : in std_logic;
		pwmCmp : in std_logic_vector(WIDTH-1 downto 0); -- from duty ROM
		pwm_out : out std_logic
	);
end pwm_gen;

architecture arch of pwm_gen is
	signal pwm_reg, pwm_next : unsigned(WIDTH-1 downto 0);
begin
	process(clk, reset)
	begin
		if reset = '1' then
			pwm_reg <= (others => '0');
		elsif (clk'event and clk = '1') then
			pwm_reg <= pwm_next;
		end if;
	end process;
	
	pwm_next <= (others => '0') when (pwm_reg = PWM_CNT-1) else
					pwm_reg + 1;
	pwm_out <= '1' when (pwm_reg < unsigned(pwmCmp)) else '0';
end arch;

