----------------------------------------------------------------------------------
-- Company: 
-- Engineer:  Groupe : ADAM HAMZA AYOUB YOUSSEF
-- 
-- Create Date:    21:28:47 24/05/2015 
-- Design Name: 
-- Module Name:    top_mod - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top_mod is
	generic
	(
		PWM_WIDTH : integer := 16;
		PWM_PERIOD : integer := 50000
	);
	port
	(
		clk, reset : in std_logic;
		desiredDuty : in std_logic_vector(6 downto 0);
		pwm_out : out std_logic
	);
end top_mod;



architecture Behavioral of top_mod is
	signal pwmCmp :std_logic_vector(15 downto 0);
begin
	pwmInst : entity work.pwm_gen(arch) generic map(PWM_CNT => PWM_PERIOD, WIDTH => PWM_WIDTH) 
													port map(clk => clk, reset => reset, pwmCmp => pwmCmp,
													pwm_out => pwm_out);

	dutyROM: entity work.duty(rom) port map(addr => desiredDuty, data => pwmCmp);
	
end Behavioral;

